// runmscr.cpp: dfinit le point d'entre pour l'application console.
//

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>

FILE *fdbg;
#ifdef _DEBUG
#define LOG_OPEN() (fdbg = _tfopen( _T("debug.txt"), _T("wt") ))
#define LOG(a,b) _ftprintf(fdbg,a)
#define LOG1(a,b) _ftprintf(fdbg,a,b)
#define LOG2(a,b,c) _ftprintf(fdbg,a,b,c)
#define LOG3(a,b,c,d) _ftprintf(fdbg,a,b,c,d)
#define LOG_CLOSE() fclose(fdbg)
#else
// this sounds stupid but if LOG_OPEN() evaluate to (0), the sw does not work anymore...
#define LOG_OPEN() (fdbg = NULL) 
#define LOG(a,b) (0)
#define LOG1(a,b) (0)
#define LOG2(a,b,c) (0)
#define LOG3(a,b,c,d) (0)
#define LOG_CLOSE() ( (fdbg) ? (fclose(fdbg)) : (0) )
#endif

TCHAR	szMortScriptPath[1024] = _T("");
TCHAR	szCommandLine[1024] = _T("");
TCHAR	szTmp[1024] = _T("");


int _tmain(int argc, _TCHAR* argv[])
{
	LONG	ret;
	DWORD	size, type;
	HKEY	key;

	LOG_OPEN();

	ret = RegOpenKeyEx( HKEY_CLASSES_ROOT,
			_T("\\MortScript\\Shell\\Open\\Command\\"),
			0,
			KEY_QUERY_VALUE,
			&key );

	LOG1(_T("RegOpenKeyEx: ret=%d\n"), ret );

	ret = RegQueryValueEx( key,
			NULL,
			NULL,
			&type,
			(LPBYTE)szMortScriptPath,
			&size );

	LOG2(_T("RegQueryValueEx: ret=%d, value=#%s#\n"), ret, szMortScriptPath );

	TCHAR *p = _tcsstr( szMortScriptPath, _T("\" \"%") );
	if ( p )
		*p = '\0';

	LOG1(_T("path=#%s#\n"), szMortScriptPath );

	_tcscpy( szCommandLine, _T("\"") );
	_tcscat( szCommandLine, argv[0] );
	p = _tcsstr( szCommandLine, _T(".exe") );
	if ( p )
		*p = '\0';
	_tcscat( szCommandLine, _T(".mscr\"") );

	for ( int argn = 1; argn < argc ; ++argn )
	{
		_stprintf( szTmp, _T(" %s") , argv[argn] );
		_tcscat( szCommandLine, szTmp );
	}

	LOG1(_T("cmdline=#%s#\n"), szCommandLine );

	PROCESS_INFORMATION processInformation;

	BOOL ok = CreateProcess(	szMortScriptPath+1,
								szCommandLine,
								NULL,
								NULL,
								FALSE,
								0, //  DWORD dwCreationFlags,
								NULL,
								NULL,
								NULL,
								&processInformation
								);

	LOG2(_T("create process=%d, %d\n"), ok, GetLastError() );

	LOG_CLOSE();

	return 0;
}

